unit Menus;

interface

	uses
		QDOffscreen, Globals, Dialogs, Windows, Graphics, Game;

{----------------------------}

	procedure SetUpMenus;
	procedure DoCommand (mResult: longint);

{----------------------------}

implementation

{----------------------------}

	procedure SetUpMenus;

		var
			i: integer;

	begin
{ create from resources }
		gameMenus.menusArray[APPLE_MENU] := GetMenu(APPLE_MENU_ID);
		AddResMenu(gameMenus.menusArray[APPLE_MENU], 'DRVR');
		gameMenus.menusArray[FILE_MENU] := GetMenu(FILE_MENU_ID);
		gameMenus.menusArray[EDIT_MENU] := GetMenu(EDIT_MENU_ID);
		gameMenus.menusArray[WINDOW_MENU] := GetMenu(WINDOW_MENU_ID);
		gameMenus.menusArray[DEV_MENU] := GetMenu(DEV_MENU_ID);

		for i := 1 to MENU_COUNT do
			InsertMenu(gameMenus.menusArray[i], 0);
		DrawMenuBar;

		with gameMenus do
			begin
				viewStatsFlag := true;
				viewPelletMatrixFlag := false;
				viewWallMatrixFlag := false;
				disableCollisionsFlag := false;
			end;
	end;

{----------------------------}

	procedure DoCommand (mResult: longint);

		var
			theItem: integer;
			theMenu: integer;
			name: Str255;
			temp: integer;

	begin
		theItem := LoWord(mResult);
		theMenu := HiWord(mResult);

		case theMenu of
			NO_MENU: 
				begin
				end;

			APPLE_MENU_ID: 
				begin
					GetItem(gameMenus.menusArray[APPLE_MENU], theItem, name);
					temp := OpenDeskAcc(name);
					SetPort(gameWindow.windowPtr);
				end;

			FILE_MENU_ID: 
				appGlobals.doneFlag := true;

			EDIT_MENU_ID: 
				begin
					if not SystemEdit(theItem - 1) then
						case theItem of
							COMMAND_CUT: 
								appGlobals.doneFlag := appGlobals.doneFlag;
							COMMAND_COPY: 
								appGlobals.doneFlag := appGlobals.doneFlag;
							COMMAND_PASTE: 
								appGlobals.doneFlag := appGlobals.doneFlag;
							COMMAND_CLEAR: 
								appGlobals.doneFlag := appGlobals.doneFlag;
							otherwise
								;
						end;
				end;  { EDIT_MENU_ID }

			WINDOW_MENU_ID: 
				begin
					case theItem of

						COMMAND_SMALL: 
							begin
								gameMenus.windowSelection := Small;
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_SMALL, true);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_MEDIUM, false);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_LARGE, false);
							end;

						COMMAND_MEDIUM: 
							begin
								gameMenus.windowSelection := Medium;
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_SMALL, false);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_MEDIUM, true);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_LARGE, false);
							end;

						COMMAND_LARGE: 
							begin
								gameMenus.windowSelection := Large;
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_SMALL, false);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_MEDIUM, false);
								CheckItem(gameMenus.menusArray[WINDOW_MENU], COMMAND_LARGE, true);
							end;
					end;

{ delete exisitng window, replace with resource and redraw }
					DisposeWindow(gameWindow.windowPtr);
					DisposeGWorld(gameWindow.offGWorld);
					SetupWindow;
					SetupGameGlobals;
					DrawScreen(true);
				end;  { WINDOW_MENU_ID }

			DEV_MENU_ID: 
				begin
					case theItem of

						COMMAND_STATS: 
							begin
								gameMenus.viewStatsFlag := not gameMenus.viewStatsFlag;
								CheckItem(gameMenus.menusArray[DEV_MENU], COMMAND_STATS, gameMenus.viewStatsFlag);
							end;

						COMMAND_PELLETMATRIX: 
							begin
								gameMenus.viewPelletMatrixFlag := not gameMenus.viewPelletMatrixFlag;
								CheckItem(gameMenus.menusArray[DEV_MENU], COMMAND_PELLETMATRIX, gameMenus.viewPelletMatrixFlag);
							end;

						COMMAND_WALLMATRIX: 
							begin
								gameMenus.viewWallMatrixFlag := not gameMenus.viewWallMatrixFlag;
								CheckItem(gameMenus.menusArray[DEV_MENU], COMMAND_WALLMATRIX, gameMenus.viewWallMatrixFlag);
							end;

						COMMAND_COLLISIONS: 
							begin
								gameMenus.disableCollisionsFlag := not gameMenus.disableCollisionsFlag;
								CheckItem(gameMenus.menusArray[DEV_MENU], COMMAND_COLLISIONS, gameMenus.disableCollisionsFlag);
							end;

					end; { case theItem of}

{ delete exisitng window, replace with resource and redraw }
					DisposeWindow(gameWindow.windowPtr);
					DisposeGWorld(gameWindow.offGWorld);
					SetupWindow;
					SetupGameGlobals;
					DrawScreen(true);
				end;  { DEV_MENU_ID }

			otherwise
				AlertWithMessage('DoCommand case theMenu error, invalid case');

		end; { case theMenu of}
		HiliteMenu(0);
	end;

{----------------------------}

end.